from collections.abc import Mapping

import atoti as tt
from atoti._external_table_identifier import ExternalTableIdentifier
from atoti.directquery._external_database_with_cache_connection import (
    ExternalDatabaseWithCacheConnection,
)
from typing_extensions import override

from .table import ClickhouseTable


class ClickhouseConnection(ExternalDatabaseWithCacheConnection[ClickhouseTable]):
    """Connection to an external ClickHouse database.

    Use :meth:`atoti.Session.connect_to_external_database` to create one.
    """

    @override
    def _create_table(
        self,
        identifier: ExternalTableIdentifier,
        /,
        *,
        types: Mapping[str, tt.DataType],
    ) -> ClickhouseTable:
        return ClickhouseTable(identifier, database_key=self._database_key, types=types)
